package com.zipcodewilmington.bakery.Services;

import com.zipcodewilmington.bakery.Models.Muffin;
import com.zipcodewilmington.bakery.Repositories.MuffinRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class MuffinService {

    private MuffinRepository muffinRepository;

    @Autowired
    public MuffinService(MuffinRepository muffinRepository) {
        this.muffinRepository = muffinRepository;
    }

    public Iterable<Muffin> find() {
        return this.muffinRepository.findAll();
    }

    public Muffin findById(Long id) {
        return this.muffinRepository.findById(id).orElse(null);
    }

    public Muffin create(Muffin muffin) {
        return this.muffinRepository.save(muffin);
    }

    public Muffin update(Long id, Muffin muffin) {
        Muffin foundMuffin = muffinRepository.findById(id).orElse(null);
        assert foundMuffin != null;
        foundMuffin.setFlavor(muffin.getFlavor());

        return this.muffinRepository.save(muffin);
    }

    public Boolean destroy(Long id) {
        this.muffinRepository.deleteById(id);
        return true;
    }
}
